<template>
  <!-- <div class="row">
    <div class="col"> -->
  <!-- Navigation bar -->
  <nav class="deu-nav navbar-expand-lg">
    <div class="deu-headline-container">
      <div class="ecl-container px-3 pb-0">
        <div class="row px-lg-3 pt-lg-3  ">
          <div
            class="d-flex justify-content-between position-relative align-items-center mobile-menu-wrap flex-column">

            <div class="pb-3 headline-wrap w-100">
              <div class="headline-wrap-inside">
                <div class="toplineHead">European data</div>
                <div class="headwrapLeft">
                  <h1 class="deu-headline m-0">data.europa.eu</h1><span class="d-none d-md-inline"> {{
                    $t('message.header.subtitle')
                  }}</span>
                </div>
              </div>

            </div>
            <!-- <div>
              <search-bar v-if="searchBarVisible" :hideOnMobileView="true" />
            </div> -->
            <!-- Hamburger menu button for mobile view -->
            <div class="hamWrapper boxShdw w-100 d-lg-none">

              <a id="hamburger-menu" href="#" class="deu-header__menu-btn menu--btn py-3 px-4 mx-2"
                 aria-expanded="false" aria-label="Toggle navigation"
                 @click="toggleMobileNavigation()">
                <font-awesome-icon :icon="['fas', 'bars']" class="deu-icon deu-icon__bars"/>
                <div>{{ $t('message.header.navigation.mobile.menu') }}</div>
              </a>
              <div v-if="searchBarVisible" class="seperatorVertical"></div>
              <div v-if="searchBarVisible"
                   class="d-lg-none d-flex flex-column align-items-center justify-content-end text-primary header-top-button py-3 px-3 mx-2 magnifierWrap"
                   :class="{ activeSearchBG: isMSearchBarVisible }"
                   @click="toggleMobileSearchBar()">
                <font-awesome-icon :icon="['fas', 'search']"
                                   class="deu-icon deu-icon__bars search-icon"/>
                <div class="HBText">Search</div>
              </div>
            </div>

          </div>
          <div v-if="isMSearchBarVisible && searchBarVisible"
               class="d-lg-none row d-flex justify-content-center mobile-search-bar-container pt-3 pb-2">
            <search-bar :hideOnMobileView="false"/>
          </div>
        </div>
      </div>
    </div>
    <div :class="{ 'overlay': isMobileNavigationExpanded, 'd-none': !isMobileNavigationExpanded }"
         @click="toggleMobileNavigation()"/>
    <div id="navbar-toggle" :class="{ 'open-mobile-navigation': isMobileNavigationExpanded }"
         class="boxShdw">
      <div class="deu-menu-container ecl-container">
        <div class="region region-primary-menu">
          <nav role="navigation" id="block-deu-main-menu" class="menu--main">
            <div class="mobile-navigation-header d-lg-none">
              <div id="mobile-header-title" class="mobile-header"
                   :class="{ 'd-none': toggledSubmenu }">{{
                  $t('message.header.navigation.mobile.menu')
                }}
              </div>
              <div id="mobile-header-back" class="mobile-header align-items-center"
                   :class="{ 'd-flex': toggledSubmenu }"
                   @click="toggleSubmenuItem(false, toggledSubmenu, 'back')"
                   tabindex="1">
                <font-awesome-icon :icon="['fas', 'chevron-down']" class="arrow-left"/>
                <div>{{ $t('message.header.navigation.mobile.back') }}</div>
              </div>
              <div class="close-container" @click="closeNavBarMenu(false, toggledSubmenu)">
                <div aria-hidden="true" class="close-circle">&times;</div>
                <div class="mt-1">{{ $t('message.header.languageSelection.close') }}</div>
              </div>
            </div>
            <ul id="menu-item-list" class="deu-menu navbar-nav ecl-menu__list"
                :class="{ 'menu-item-list-toggle-background': toggledSubmenu }">
              <!-- Dynamic navigation items -->
              <li v-for="(menuItem, i) in computeMenuItems" :key="`menuItem@${i}`" :class="{
                'active': activeMenuItem === menuItem.id || activeMenuItem === i,
                'd-none': toggledSubmenu !== i && toggledSubmenu,
                'menu-item-hide-border': toggledSubmenu,
              }" class="deu-menu__item nav-item dropdown ">
                <template v-if="menuItem.subMenuItems && menuItem.subMenuItems.length > 0">
                  <!-- Render menu item with sub items -->
                  <div class="justify-content-between liWrapper"
                       :class="{ 'd-flex': !activeSubMenu, }">
                    <button class="px-0 " :class="{ 'd-none': isSubitemSelected }" fragment="#"
                            type="button"
                            @click="handleClick(i, menuItem.to, 'break')">
                      <div class="deu-menu__item-content">
                        <span>{{ menuItem.title }}</span>
                      </div>
                    </button>
                    <div>
                      <button class="nav-link dropdown-toggle px-md-0 px-3 w-100 pb-12"
                              :class="{ 'drupalBtnStyleMobileMenu': activeSubMenu }" fragment="#"
                              :id="`navbarDropdownMenuLink${i}`" type="button" aria-haspopup="true"
                              aria-expanded="false"
                              @click="toggleSubmenuItem(true, i, 'enable');">
                        <div class="deu-menu__item-content">
                          <span :class="{ 'd-none': !isSubitemSelected }"
                                @click="handleClick(i, menuItem.to)">
                            {{ menuItem.title }}
                          </span>
                          <font-awesome-icon :icon="['fas', 'chevron-down']"
                                             class="deu-icon deu-icon__menu-item-arrow-down  ml-md-0"
                                             :class="{ 'd-none': toggledSubmenu }"/>
                        </div>
                      </button>
                      <!-- <form class="deu-menu__dropdown dropdown-menu"
                            :aria-labelledby="`navbarDropdownMenuLink${i}`">
                        <ul class="deu-menu__dropdown-list">
                          <li v-for="(subItem, j) in menuItem.subMenuItems"
                              :key="`subMenuItem@${i}-${j}`"
                              class="deu-menu__dropdown-list-item" :class="{
                              'd-none': i === 1 && j === 1 && !(showSparql === true)
                            }">
                            <app-link :to="subItem.to" active-class="active">
                              {{ subItem.title }}
                              <AccessLinkIcon v-if="subItem.accessIcon"></AccessLinkIcon>

                            </app-link>
                          </li>
                        </ul>


                      </form> -->
                      <form class="deu-menu__dropdown dropdown-menu"
                            :aria-labelledby="`navbarDropdownMenuLink${i}`"
                            :style="{ width: menuItem.subMenuItems.length > 4 ? '430px' : 'auto' }">
                        <!-- First row: display first 4 items -->
                        <div class="row">
                          <div class="col-6">
                            <ul class="deu-menu__dropdown-list">
                              <li v-for="(subItem, j) in menuItem.subMenuItems.slice(0, 4)"
                                  :key="`subMenuItem@${i}-${j}`"
                                  class="deu-menu__dropdown-list-item" :class="{
                                  'd-none': i === 1 && j === 1 && !(showSparql === true), active: isSubItemMenuActive(subItem)
                                }" @click="handleSubItemMenuClick(subItem)">
                                <app-link :to="subItem.to" active-class="active"
                                          :target="subItem.accessIcon ? '_blank' : '_self'">
                                  {{ subItem.title }}
                                  <AccessLinkIcon v-if="subItem.accessIcon"></AccessLinkIcon>
                                </app-link>
                              </li>
                            </ul>
                          </div>
                          <div class="col-6">
                            <!-- Second row: display items after the 4th item: -->
                            <ul class="deu-menu__dropdown-list">
                              <li v-for="(subItem, j) in menuItem.subMenuItems.slice(4)"
                                  :key="`subMenuItem@${i}-${j + 4}`"
                                  class="deu-menu__dropdown-list-item" :class="{
                                  'd-none': i === 1 && j === 1 && !(showSparql === true), active: isSubItemMenuActive(subItem)
                                }" @click="handleSubItemMenuClick(subItem)">
                                <app-link :to="subItem.to" active-class="active">
                                  {{ subItem.title }}
                                  <AccessLinkIcon v-if="subItem.accessIcon"></AccessLinkIcon>
                                </app-link>
                              </li>
                            </ul>
                          </div>
                        </div>
                      </form>
                    </div>
                  </div>

                </template>
                <template v-else-if="i == Object.keys(computeMenuItems).length - 1">
                  <!-- Render menu item without sub items -->
                  <app-link class="menuItemHeader" :to="menuItem.to">
                    <button class="nav-link deu-menu__without-subitem px-0 ">
                      <div class="deu-menu__item-content">
                        <span>{{ menuItem.title }}</span>
                        <AccessLinkIcon v-if="menuItem.accessIcon"></AccessLinkIcon>
                      </div>
                    </button>

                  </app-link>

                </template>
                <template v-else>
                  <!-- Render menu item without sub items -->
                  <app-link class="menuItemHeader" :to="menuItem.to">
                    <button class="nav-link deu-menu__without-subitem px-0 ">
                      <div class="deu-menu__item-content">
                        <span>{{ menuItem.title }}</span>
                        <AccessLinkIcon v-if="menuItem.accessIcon"></AccessLinkIcon>
                      </div>
                    </button>

                  </app-link>
                </template>

              </li>
            </ul>
          </nav>
        </div>
      </div>
    </div>

  </nav>
  <!-- </div>
  </div> -->
</template>

<script>
import {FontAwesomeIcon} from '@fortawesome/vue-fontawesome';
import AppLink from '../common/AppLink.vue';
import AccessLinkIcon from '../common/AccessLinkIcon.vue';
import SearchBar from './SearchBar.vue';


export default {
  name: 'HeaderBottom',
  components: {
    FontAwesomeIcon,
    AppLink,
    AccessLinkIcon,
    SearchBar
  },
  props: {
    project: {
      type: String,
      default: 'hub',
    },
    activeMenuItem: {
      type: [String, Number],
      default: 'data',
    },
    useLanguageSelector: {
      type: Boolean,
      default: true,
    },
    menuItemsHook: {
      type: Function,
      default: (menuItems) => menuItems,
    },
    showSparql: {
      type: Boolean,
      default: true,
    },
    selectedLanguage: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      openDropdown: null,
      isMobileNavigationExpanded: false,
      isSubitemSelected: false,
      toggledSubmenu: null,
      activeSubMenu: false,
      firstEnable: false,
      searchBarVisible: false,
      isMSearchBarVisible: false,
      windowWidth: window.innerWidth,
    };
  },
  computed: {
    computeMenuItems() {
      const menuItems = [
        {
          // =============== HOME ==============
          id: 'home',
          to: `/${this.$route.query.locale}`,
          title: this.$t('message.header.navigation.home'),
        },
        {
          // =============== DATA ==============
          id: 'data',
          to: `/data/datasets?locale=${this.$route.query.locale}`,
          title: this.$t('message.header.navigation.data.title'),
          subMenuItems: [
            {
              to: `/data/datasets?locale=${this.$route.query.locale}`,
              title: this.$t('message.header.navigation.data.search'),
            },
            {
              to: `/data/sparql?locale=${this.$route.query.locale}`,
              title: this.$t('message.header.navigation.data.sparqlsearch'),
            },
            {
              to: `https://data.europa.eu/api/hub/search/`,
              title: this.$t('message.header.navigation.data.API'),
              // title: "API Search",
              accessIcon: true,
            },
            {
              to: `/mqa?locale=${this.$route.query.locale}`,
              title: this.$t('message.header.navigation.data.metadataquality'),
            },
            {
              to: `/catalogue-statistics/currentState?locale=${this.$route.query.locale}`,
              title: this.$t('message.header.navigation.data.statistics'),
            },
            {
              to: `/data/datasets?is_hvd=true&locale=${this.$route.query.locale}`,
              title: this.$t('message.header.navigation.data.highValueDatasets'),
            },
            {
              to: `/data/datasets?superCatalog=erpd&locale=${this.$route.query.locale}`,
              title: this.$t('message.header.navigation.data.erpd'),
            },
            {
              to: `/licensing-assistant/licences?locale=${this.$route.query.locale}`,
              title: this.$t('message.header.navigation.training.licensingAssistant'),
            }
          ]
        },
        {
          // =============== EU OPEN DATA DAYS ==============
          id: 'euopendatadays',
          to: `/${this.$route.query.locale}/euopendatadays`,
          title: "EU Open Data Days",
        },

        {
          // =============== DATA.EUROPA ACADEMY ==============
          id: 'training',
          to: `/${this.$route.query.locale}/academy`,
          title: this.$t('message.header.navigation.training.dataEuropaAcademy'),
        },
        {
          // =============== Navigation item Community ==============
          id: 'Community',
          to: `/dashboard/${this.$route.query.locale}`,
          title: this.$t('message.header.navigation.community.title'),
          subMenuItems: [
            {
              to: `/${this.$route.query.locale}/apps`,
              title: this.$t('message.header.navigation.community.apps'),
            },
            {
              to: `/${this.$route.query.locale}/podcasts`,
              title: this.$t('Podcasts'),
            },
            {
              to: `/dashboard/${this.$route.query.locale}/community/collaboration-channel`,
              title: this.$t('Collaboration channel'),
            },
             {
              to: `/${this.$route.query.locale}/news-events/events`,
              title: this.$t('message.header.navigation.newsEvents.events'),
            },
            {
              to: `/${this.$route.query.locale}/contact-us`,
              title: this.$t('message.header.subnav.contact'),
            },
          ],
        },

        {
          // =============== STUDIES ==============
          id: 'impactAndStudies',
          to: `/${this.$route.query.locale}/impact-studies/overview`,
          title: this.$t('message.header.navigation.impactStudies.publications'),
          subMenuItems: [
            {
              to: `/${this.$route.query.locale}/impact-studies/overview`,
              title: this.$t('message.header.navigation.impactStudies.overview'),
            },
            {
              to: `/${this.$route.query.locale}/impact-studies/open-data-maturity`,
              title: this.$t('message.header.navigation.impactStudies.opendatamaturity'),
            },
            {
              to: `/${this.$route.query.locale}/publications/datastories`,
              title: this.$t('message.header.navigation.newsEvents.stories'),
            },
            {
              to: `/${this.$route.query.locale}/news-events/news`,
              title: this.$t('message.header.navigation.newsEvents.news'),
            },
            {
              to: `/${this.$route.query.locale}/news-events/newsletter`,
              title: this.$t('message.header.subnav.newsletter'),
            },
            {
              to: `/${this.$route.query.locale}/publications/studies`,
              title: this.$t('message.header.navigation.impactStudies.studies'),
            },
            {
              to: `/${this.$route.query.locale}/impact-studies/country-insights`,
              title: this.$t('message.header.navigation.impactStudies.countyInsights'),
            },
          ],
        },
        // {
        //   // =============== NEWS ==============
        //   id: 'newsAndEvents',
        //   to: `/${this.$route.query.locale}/news-events/news`,
        //   title: this.$t('message.header.navigation.newsEvents.title'),
        //   subMenuItems: [
        //     {
        //       to: `/${this.$route.query.locale}/news-events/news`,
        //       title: this.$t('message.header.navigation.newsEvents.news'),
        //     },
        //     {
        //       to: `/${this.$route.query.locale}/news-events/events`,
        //       title: this.$t('message.header.navigation.newsEvents.events'),
        //     },
        //     {
        //       to: 'https://op.europa.eu/en/web/euopendatadays',
        //       title: this.$t('message.header.navigation.newsEvents.euopendatadays'),
        //       accessIcon: true,
        //     },
        //     {
        //       to: 'https://op.europa.eu/en/web/eudatathon',
        //       title: this.$t('message.header.navigation.newsEvents.eudatathon'),
        //       accessIcon: true,
        //     },
        //     {
        //       to: `/${this.$route.query.locale}/news-events/newsletter`,
        //       title: this.$t('message.header.subnav.newsletter'),
        //     },
        //   ],
        // },
        {
          // =============== DOCUMENTATION ==============
          id: 'documentation',
          to: 'https://dataeuropa.gitlab.io/data-provider-manual/',
          title: this.$t('message.header.navigation.documentation'),
          accessIcon: true,
        },

      ];
      this.adjustMenuItemsToProject(menuItems, this.project);
      return this.menuItemsHook(menuItems);
    },
  },
  methods: {
    handleSubItemMenuClick(item) {
      localStorage.setItem('activeSubItemMenu', item.title);
      this.openDropdown = null;
    },

    isSubItemMenuActive(item) {
      return localStorage.getItem('activeSubItemMenu') === item.title;
    },
    initheaderlinks() {
      // quickfix for the white seperators in the Header Links

      let navItems = document.getElementsByClassName("deu-menu__item");
      for (let i = 0; i < navItems.length; i++) {

        if (i % 2 === 0) {
          navItems[i].childNodes[0].classList?.add("border-right-left");
        }
        if (i + 1 === navItems.length && i % 2 !== 0) {
          navItems[i].childNodes[0].classList?.add("border-right-right");
        }
      }
    },
    initSearchBar() {

      this.searchBarVisible = this.showSearchBar(window.location.pathname);
    },
    toggleMobileSearchBar() {

      this.isMSearchBarVisible = !this.isMSearchBarVisible;
    },
    handleClick(i, to, action) {
      console.log(this.activeSubMenu);
      if (action === 'break') {
        window.location.href = to;
      } else {
        if (this.activeSubMenu) {
          console.log('inside!');
        } else {
          this.activeSubMenu = !this.activeSubMenu;
        }

        // if(e.target == ".deu-menu")
        // Check for external URLs
        if (typeof to !== 'object') {
          window.location.href = to;
        } else {
          this.$router.push(to);
        }

      }

    },

    adjustMenuItemsToProject(menuItems, project) {
      // Deep clone menuItems
      const menuItemsClone = JSON.parse(JSON.stringify(menuItems));

      const dataSubMenuItems = menuItemsClone[1].subMenuItems;
      switch (project) {
        case 'hub':
          dataSubMenuItems[0].to = {
            name: 'Datasets',
            query: {locale: this.$route.query.locale}
          };
          dataSubMenuItems[1].to = {
            name: 'SparqlSearch',
            query: {locale: this.$route.query.locale}
          };
          break;
        case 'metrics':
          dataSubMenuItems[3].to = {
            name: 'Dashboard',
            query: {locale: this.$route.query.locale}
          };
          break;
        case 'statistics':
          dataSubMenuItems[2].to = {
            name: 'CurrentState',
            query: {locale: this.$route.query.locale}
          };
          break;
        default:
          break;
      }

      return menuItemsClone;
    },
    toggleMobileNavigation() {
      let isExpanded = document.getElementById('hamburger-menu')
        .getAttribute('aria-expanded');
      if (isExpanded === 'true') {
        isExpanded = 'false';
        this.isMobileNavigationExpanded = false;
      } else {
        isExpanded = 'true';
        this.isMobileNavigationExpanded = true;
      }
      document.getElementById('hamburger-menu')
        .setAttribute('aria-expanded', isExpanded);
    },
    toggleSubmenuItem(expand, key, indicator) {

      if (this.windowWidth > 991) {
        return;
      }
      if (indicator === 'enable' && this.firstEnable) {
        return;
      }
      if (indicator === 'enable' && !this.activeSubMenu) {
        this.activeSubMenu = !this.activeSubMenu;
        this.firstEnable = true;
      }
      if (this.activeSubMenu && indicator === 'back') {
        this.activeSubMenu = !this.activeSubMenu;
        this.firstEnable = false;
      }
      if (this.isMobileNavigationExpanded) {
        let shouldExpand;
        this.isSubitemSelected = !this.isSubitemSelected;
        if (expand) {
          shouldExpand = 'true';
          this.toggledSubmenu = key;
        } else {
          shouldExpand = 'false';
          this.toggledSubmenu = null;
        }
        document.getElementById(`navbarDropdownMenuLink${key}`)
          .setAttribute('aria-expanded', shouldExpand);
      }

    },
    closeNavBarMenu(expand, key) {
      if (this.isSubitemSelected) this.toggleSubmenuItem(expand, key);
      this.toggleMobileNavigation();
    },
    showSearchBar(path) {
      if (path === '/datasets') return false;
      if (path === '/data/datasets') return false;
      if (path === '/catalogues') return false;
      if (path === '/data/catalogues') return false;
      return true;
    },
  },
  watch: {
    $route(to) {
      this.searchBarVisible = this.showSearchBar(to.path);
    },
  },
  created() {
    this.initSearchBar();
  },
  mounted() {
    this.initheaderlinks();
  }
};
</script>

<style lang="scss" scoped>
@import '../../../src/styles/header.scss';

$deu-active: $highlight;

// .seperator {
//   height: 30px;
//   width: 1px;
//   background: white;
// }

// .deu-menu__dropdown {
//   padding-top: 20px !important;
//   padding-bottom: 10px !important;
// }
.activeSearchBG {
  background: #F3F6FC;

  svg {
    color: $primary
  }

  div {
    color: $primary
  }
}

//added from Majid
.deu-menu__dropdown-list-item.active {
  margin-left: 0;
  background-color: $primary-lightest !important;
  border-left: 5px solid $primary-lighter;

  a {
    color: #0e47cb !important;
  }
}

/*.deu-menu__dropdown-list-item:active {
  background-color: none;
}*/

.mobile-search-bar-container {
  position: absolute;
  top: 96%;
  width: 100%;
  left: 15px;
  box-shadow: 0 3px 5px rgba(9, 49, 142, .04);

  input {
    background: #fff;
  }

  z-index: 49;
  flex-grow: 1;
  background-color: #F3F6FC;
}

.deu-menu__dropdown-list {
  display: flex;
  flex-wrap: wrap;
  text-underline-offset: 4px !important;
}


.seperatorVertical {

  margin: auto 0 auto 0;
  height: 65%;
  background-color: white;
  width: 1px;
}

.HBText {
  font-size: 12px;
  color: #fff;
}

.magnifierWrap {
  svg {
    width: 20px;
    height: 18px;
  }

}

#menu-item-list {
  padding: 0 1rem;
}

.minus-margin {
  margin: 0 -1px !important;
}

.menuItemHeader {
  display: flex;
  align-items: center;
}

.dropdown-toggle {

  .deu-menu__item-content {
    padding: 0;
    margin-left: 8px;
  }


}


.deu-headline-container {
  background-color: white;

  .ecl-container {
    &::before {
      border-top: 2px solid #cfdaf5;
      content: "";
      width: 97%;
      position: absolute;
      top: -1px;
    }


  }
}

.toplineHead {
  -webkit-margin-end: 0;
  align-self: center;
  color: #515560;
  flex-grow: 1;
  font: normal normal 400 2rem/2.5rem arial, sans-serif;
  font-weight: 700;
  margin-inline-end: 0;

}

.deu-menu__without-subitem :hover {
  border-bottom: 0px !important;
}

.deu-menu__without-subitem :focus {
  border-bottom: 0px !important;
}

.deu-menu__without-subitem :hover {
  border-bottom: 0px !important;
}

.deu-menu__without-subitem :focus {
  border-bottom: 0px !important;
}

.deu-headline {
  background-color: #f4f5f5 !important;
  padding: 0.33rem 0.75rem;
  -ms-flex-item-align: center;
  align-self: center;
  font-size: 1.125rem !important;
  font-weight: 700 !important;
  border-left: solid 6px #f2718a;
  color: rgb(77, 82, 87);
  // margin: 0.357rem 0;
  font-size: 1.75rem;
  font-weight: bold;
  text-decoration: none;
}

.headwrapLeft {
  display: flex;
  align-items: center;
  margin-top: 0.375rem;

  span {
    margin-left: 0.75rem;
    color: #515560 !important;
    font: normal normal 400 1rem/1.5rem arial, sans-serif !important;
    font-weight: 700 !important;
  }
}

.deu-menu__item-content {

  white-space: nowrap;
  padding: 8px !important;
  text-underline-offset: 4px !important;
}

.deu-menu__item-content > span {
  font: normal normal 400 1rem/1.25rem arial, sans-serif;
}

#navbar-toggle {
  background: linear-gradient(90deg, #082b7a, #0e47cb);
  position: sticky;
  z-index: 99;
  top: 0;
  box-shadow: 0 3px 5px rgba(9, 49, 142, .04), 0 0 18px rgba(9, 49, 142, .04), 0 6px 10px rgba(9, 49, 142, .04), 0 -4px 4px rgba(9, 49, 142, .04);
}

.drupalPadding {
  -webkit-padding-end: 12px;
  padding-inline-end: 12px;
}

.pb-12 {
  // padding-bottom: 12px !important;
}

.deu-menu {

  // Navigation bar/first-level menu
  &__item {


    list-style-type: none;
    list-style-image: none;
    margin: 0;
    padding: 0;
    flex: 0 1 auto;

    &:hover button {
      background-color: white;
      color: $text-blue;
      z-index: 9;

    }

    button:hover div {
      text-decoration: underline;
    }

    &:hover button ~ .deu-menu__dropdown {
      display: block;
    }

    &.active {
      div {
        color: $primary;
      }

      background-color: #e7edfa;
      text-underline-offset: 4px !important;
      z-index: 9;
    }

    &.show {
      background-color: $primary-lightest;
    }

    a {
      border: none;
      outline: none;
      outline-offset: 0;
    }

    button {
      // border: 3px solid transparent;
      border: none;
      background: transparent;
      color: white;
      //display: inline-block;
      cursor: pointer;
      padding: 0.5rem .25rem 0.5rem .5rem;
      text-align: center;
      //display: block;

      //border-bottom: 3px solid transparent;
    }

    // Override bootstrap dropdown arrow
    .dropdown-toggle::after {
      content: "";
      display: inline-block;
      border-top: 0.0em solid;
      border-right: 0.0em solid transparent;
      border-bottom: 0;
      border-left: 0.0em solid transparent;
      font-weight: 900;
      margin-left: 10px;
      vertical-align: 0;
    }
  }

  &__without-subitem {

    &:hover {
      // border-bottom: 3px solid #bfd0e4 !important;
    }

    &:focus {
      border: 0px solid $highlight !important;
      border-bottom: 0px solid #bfd0e4 !important;
      background-color: $primary-lightest;
      color: $text-blue;
    }

    &:focus > div {
      text-decoration: underline;
    }
  }

  &__item-content {
    font-size: $font-size-navbar-primary;
    display: inline-flex;
    align-items: baseline;
    //margin-left: 8px;
    padding: 0 16px;
    position: relative;

    // Explicitly add whitespace after header title content
    // to match data.europa.eu design
    // Seems like a bug on their side...
    // span::after {
    //   content: " ";
    //   white-space: pre;
    // }
  }

  // Second-level/dropdown menu styling
  &__dropdown {
    z-index: 9;
    background-color: white;
    position: absolute;
    min-width: 100%;
    //  padding-top: 20px;
    // padding-bottom: 20px;
    margin-top: 0px;

    display: none;
    z-index: -1;
    box-shadow: 0 3px 5px rgba(9, 49, 142, .04), 0 0 18px rgba(9, 49, 142, .04), 0 6px 10px rgba(9, 49, 142, .04), 0 -4px 4px rgba(9, 49, 142, .04);
    border: none;

    border-radius: 0;
    transform: none !important;
    top: 100% !important;
  }

  &__dropdown-list {
    padding: 0;
  }

  &__dropdown-list-item {
    list-style-type: none;
    list-style-image: none;
    padding: 3px 0;
    margin-bottom: calc(1rem - 12px);
    width: 100%;

    a {
      margin-inline-start: 8px;
      margin-inline-end: 1rem;
      padding-top: 8px;
      padding-left: 6px;
      padding-right: 6px;
      padding-bottom: 6px;
      display: block;
      color: $primary;

      &:focus {
        outline-offset: 3px;
      }
    }
  }
}


.border-right-left {
  border-right: 1px solid #6e91e0 !important;
  border-left: 1px solid #6e91e0 !important;
  height: 30px;
  align-items: center;
}

.border-right-right {
  border-right: 1px solid #fff !important;
  height: 30px;

  align-items: center;
}

.deu-menu__item {

  display: flex;
  align-items: center;
  margin: 0 -1px !important;

  &.show {
    .deu-menu__item-content {
      color: $primary;
    }
  }

  &:hover {
    background-color: white !important;

    svg.deu-icon__menu-item-arrow-down {
      transform: rotate(180deg);

    }
  }
}

.deu-menu-container {
  padding: 0 !important;
}

// Mobile view
@media only screen and (max-width: $laptop) {

  .drupalBtnStyleMobileMenu {
    font-size: 1.5rem !important;
    font-weight: 700 !important;
    border-bottom: 3px solid #bfd0e4 !important;
  }

  .drupalBtnStyleMobileMenu {
    .deu-menu__item-content {
      font-size: 20px !important;
      color: #004494 !important;
      color: #004494 !important;
    }

    font-weight: 700 !important;
    border-bottom: 3px solid #bfd0e4 !important;
  }

  .deu-menu-container {
    padding-left: 0;
    padding-right: 0;
  }

  .deu-menu {
    button:hover div {
      text-decoration: none;
    }
  }

  #menu-item-list {
    display: block;

  }

  .deu-menu {
    // Menu styling
    overflow: hidden;
    height: calc(100vh - 81px);
    max-height: 100%;
    overflow-y: scroll;
    padding-bottom: 50px;
    align-items: start;

    &__without-subitem {
      border: 0px solid transparent !important;

      &:hover {
        border: 0px solid transparent !important;
      }

      &:focus {
        border: 0px solid $highlight !important;
        background-color: transparent;
        color: #fff;
        transition: none;
      }
    }

    &__item {
      // margin: 0 1rem;
      border-top: 1px solid #7fa1c9;
      border-bottom: none !important;


      &:hover button {
        background-color: transparent;
        color: white;

      }

      .nav-link {
        text-align: left;
        padding: 1rem 0;
        font-weight: 700;

      }

      &.show {
        background-color: transparent;
      }

      &.active {
        // Highlights the current 'active' route
        // Special styling for mobile only
        background-color: transparent;


        .deu-menu__dropdown {
          padding: 5px 15px 0 15px;
        }
      }

      & > a {
        text-align: left;
        font-weight: bold;
      }

      &--home {
        flex: 0;
        font-size: $font-size-navbar-primary;

        .deu-menu__home-text {
          color: $primary;
          display: inline-block;
        }

        .deu-icon__home {
          margin-right: 5px;
        }

        & > a {
          padding: 7px 0 7px 15px;
        }
      }
    }

    &__item-content {
      margin: 0;
      font-size: 1rem;
    }

    .deu-icon {
      transform: rotate(-90deg) !important;
    }

    &__dropdown {
      display: none !important;
      text-align: left;
      position: relative;
      background-color: transparent;
      padding: 0 0 10px 0 !important;
      box-shadow: none;
      border: none;
      // Override bootstrap's attempt to apply dropdown menu styling
      // when on mobile view mode
      // position: relative !important;
      // will-change: initial !important;
      // top: auto !important;
      // left: auto !important;
      // transform: none !important;
    }

    .nav-link[aria-expanded="true"] {
      color: $text-blue;
      cursor: default;
    }

    .nav-link[aria-expanded="true"] + form {
      display: block !important;
    }

    &__dropdown-list-item {
      padding: 0;
      margin: 0;
      border-top: 1px solid #bfd0e4;

      a {
        margin-inline-start: 0;
        margin-inline-end: 0;
        border-top: none;
        padding: 11px 1rem;
        background-color: transparent;
        text-align: left;
        width: 100%;

        span {
          margin-left: 8px;
        }

        // &.active, &:hover {
        //   color: white;
        // }

        &.active {
          // text-underline-offset: 4px  !important;
          display: list-item;
          list-style-type: disc;
          list-style-image: url(../../../src/assets/img/menu-collapsed.png);
        }
      }
    }
  }

  .boxShdw {
    box-shadow: 0 3px 5px rgba(9, 49, 142, .04), 0 0 18px rgba(9, 49, 142, .04), 0 6px 10px rgba(9, 49, 142, .04), 0 -4px 4px rgba(9, 49, 142, .04);

  }

  .overlay {
    background-color: rgba(0, 0, 0, .5);
    height: 100%;
    left: 0;
    position: fixed;
    right: 0;
    top: 0;
    width: 100%;
    z-index: 52;
  }

  #navbar-toggle {
    position: fixed;
    background-color: $primary;
    margin-bottom: 0;
    height: 100%;
    overflow-y: auto;
    z-index: 53;
    right: -100%;
    width: 100%;
    transition: all 375ms;
    // color: #fff;

    @media only screen and (min-width: 576px) {
      right: -25rem;
      width: 25rem;
    }
  }

  .open-mobile-navigation {
    right: 0 !important;
  }

  .mobile-navigation-header {
    background: linear-gradient(90deg, #082b7a, #0e47cb);
    padding: 1rem;
    position: sticky;
    top: 0;
    z-index: 52;
    display: flex;
    align-items: center;
    justify-content: space-between;
  }

  .mobile-header {
    font-size: 1.25rem;
    font-weight: 700;
  }

  #mobile-header-back {
    display: none;
    padding: .75rem .5rem;
    margin: -.75rem -.5rem;
    // border: 3px solid transparent;
    cursor: pointer;
    user-select: none;

    &:focus {
      border: 3px solid yellow !important;
    }
  }

  .arrow-left {
    transform: rotate(90deg);
    margin-right: 0.5rem;
  }

  .close-container {
    display: flex;
    flex-direction: column;
    align-items: center;
    cursor: pointer;
    padding: 0.25rem;

    &:hover {
      color: lightgrey;
    }
  }

  .close-circle {
    border: 1px solid #fff;
    padding: 5px;
    border-radius: 100% !important;
    width: 20px;
    height: 20px;
    font-family: sans-serif !important;
    display: flex;
    justify-content: center;
    align-items: center;

    + div {
      font-size: 0.75rem;
    }
  }

  .menu-item-list-toggle-background {
    background-color: $primary-lightest;
  }

  .menu-item-hide-border {
    border-top: none;
  }
}

@media only screen and (min-width: $laptop) {
  .overlay {
    display: none;
  }
}
</style>
